#include <string.h>

#include <xa.h>

extern struct xa_switch_t iitux_switch;

static void init();

static int open(char *a, int rmid, long l) {
	init();
	return iitux_switch.xa_open_entry(a, rmid, l);
}
static int close(char *a, int rmid, long l) {
	return iitux_switch.xa_close_entry(a, rmid, l);
}
static int start(XID *x, int rmid, long l) {
	return iitux_switch.xa_start_entry(x, rmid, l);
}
static int end(XID *x, int rmid, long l) {
	return iitux_switch.xa_end_entry(x, rmid, l);
}
static int prepare(XID *x, int rmid, long l) {
	return iitux_switch.xa_prepare_entry(x, rmid, l);
}
static int commit(XID *x, int rmid, long l) {
	return iitux_switch.xa_commit_entry(x, rmid, l);
}
static int rollback(XID *x, int rmid, long l) {
	return iitux_switch.xa_rollback_entry(x, rmid, l);
}
static int recover(XID *xid, long l1, int rmid, long flags) {
	return iitux_switch.xa_recover_entry(xid, l1, rmid, flags);
}
static int forget(XID *x, int rmid, long l) {
	return iitux_switch.xa_forget_entry(x, rmid, l);
}
static int complete(int *ip1, int *ip2, int rmid, long l) {
	return iitux_switch.xa_complete_entry(ip1, ip2, rmid, l);
}

struct xa_switch_t iibt_switch = {
	"", 0L, 0,
	open, close,
	start, end, rollback, prepare, commit,
	recover,
	forget,
	complete
};

static void init() {
/*	snprintf(iibt_switch.name, RMNAMESZ, "%s", iitux_switch.name);*/
	strncpy(iibt_switch.name, iitux_switch.name, RMNAMESZ);
	iibt_switch.flags = iitux_switch.flags;
	iibt_switch.version = iitux_switch.version;
}
